#include "mixer3.h"

#include "sigmoid.h"

#include <numeric>
#include <math.h>

Mixer3::Mixer3(const std::valarray<float>& inputs,
    unsigned long long input_size) : inputs_(inputs), p_(0.5),
    lstm_(input_size, 2, 50, 2, 40, 0.001, 10) {}

float Mixer3::Mix() {
  return p_;
}

void Mixer3::Perceive(int bit) {
  for (unsigned int i = 0; i < inputs_.size(); ++i) {
    lstm_.SetInput(i, 0/*(Sigmoid::Logistic(inputs_[i]) - 0.5) / 10000*/);
  }
  p_ = lstm_.Perceive(bit)[0];
}

